package org.foxarmy.barcodescannerforemployees.activities

import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKeys
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.databinding.ActivityGroupBinding

class GroupActivity : AppCompatActivity() {

    private lateinit var binding: ActivityGroupBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityGroupBinding.inflate(layoutInflater)
        setContentView(binding.root)

        val masterKeyAlias = MasterKeys.getOrCreate(MasterKeys.AES256_GCM_SPEC)

        val sharedPreferences = EncryptedSharedPreferences.create(
            "sensitive",
            masterKeyAlias,
            applicationContext,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )

        binding.createGroupButton.setOnClickListener {
            val groupName = binding.groupNameTextEdit.text.toString()
            val groupPassword = binding.groupPasswordTextEdit.text.toString()

            val n = Net()
            n.language = sharedPreferences.getString("language", "en-US")!!
            n.server = sharedPreferences.getString("server", "")!!
            n.token = sharedPreferences.getString("token", "")!!

            val response = n.createGroup(groupName, groupPassword)
            val responseText = response.body!!.string()
            Toast.makeText(this, responseText, Toast.LENGTH_LONG).show()

            if (response.code == 200) {
                Toast.makeText(this, responseText, Toast.LENGTH_LONG).show()
                sharedPreferences.edit().putStringSet("groups", setOf(responseText))
                val intent = Intent(this, MainActivity::class.java)
                startActivity(intent)
                finish()
            }
        }
    }
}